#@PydevCodeAnalysisIgnore
#---------------------------------------------------------------------------------------------------
# Copyright (C) 2009 Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com>.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# Contributors:
#     Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com> - initial API and implementation
#---------------------------------------------------------------------------------------------------

import nautilus
import urlparse
import urllib
import wx
import gettext, locale
from fbupload import fbnautilusupload

SUPPORTED_FORMATS = 'image/jpeg', 'image/png', 'image/gif', 'application/octet-stream', 'image/tiff', 'image/vnd.wap.wbmp', 'image/x-xbitmap'

class FacebookPhotoUploadExtension(nautilus.MenuProvider):
    def __init__(self):
        locale.setlocale(locale.LC_ALL, '')
        gettext.install("fbupload") 
    
    def check_files_types(self,files):
        for file in files:
            if file.get_mime_type() not in SUPPORTED_FORMATS:
                return False
        return True
    
    def activate_upload(self,menu,files):
        choices=[]
        for file in files:
            choices.append(urlparse.urlparse(urllib.url2pathname(file.get_uri())).path)
        FU = wx.PySimpleApp(0)
        wx.InitAllImageHandlers()
        FOS = fbnautilusupload.FacebookOpenSessionDialog(choices, None, -1, "")
        FU.SetTopWindow(FOS)
        FOS.Show()
        FU.MainLoop()

    def get_file_items(self,window,files):
        if len(files) == 0:
            return
        if not self.check_files_types(files):
            return
        item=nautilus.MenuItem('Nautilus::FacebookPhotoUploadExtension',_('Upload on facebook'),_('Upload image on facebook'))
        item.set_property('icon','FBUIcon')
        item.connect('activate',self.activate_upload,files)
        return item,
