#!/usr/bin/env python
# -*- coding: utf-8 -*-

#---------------------------------------------------------------------------------------------------
# Copyright (C) 2009 Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com>.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# Contributors:
#     Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com> - initial API and implementation
#---------------------------------------------------------------------------------------------------

# generated by wxGlade 0.6.3 on Mon Aug  3 02:38:23 2009

import wx
from wx.lib.newevent import NewEvent
import os
from fbupload import fbphotoupload
import gettext, locale
import webbrowser
import thread
import Image
import time

(setAlbums, EVT_SET_ALBUMS) = NewEvent()
(clearAlbums, EVT_CLEAR_ALBUMS) = NewEvent()
(setProgress, EVT_SET_PROGRESS) = NewEvent()
(setLabel, EVT_SET_LABEL) = NewEvent()
(setStats, EVT_SET_STATS) = NewEvent()
ICON_PATH=os.path.join('/usr','share','pixmaps','FBUIcon.png')

class FacebookOpenSessionDialog(wx.Dialog):
    
    def __init__(self, files, *args, **kwds):
        locale.setlocale(locale.LC_ALL, '')
        gettext.install("fbupload") 
        self.files=files
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.FOSST = wx.StaticText(self, -1, _("Opening browser...\nclose this message after you follow the instructions."), style=wx.ALIGN_CENTRE)
        self.FOSB = wx.Button(self, wx.ID_OK, "")
        self.__set_properties()
        self.__do_layout()
        self.__do_evt()
        try:
            self.fb = fbphotoupload.PhotoUpload()
        except:
            dlg = wx.MessageDialog(self,_("Connection Error"),_('Error'),wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            self.Destroy()

    def __set_properties(self):
        self.SetTitle(_("Facebook Open Session"))
        _icon = wx.EmptyIcon()
        _icon.CopyFromBitmap(wx.Bitmap(ICON_PATH, wx.BITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        self.SetSize((400, 76))

    def __do_layout(self):
        FOSS = wx.BoxSizer(wx.VERTICAL)
        FOSS.Add(self.FOSST, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 5)
        FOSS.Add(self.FOSB, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        self.SetSizer(FOSS)
        self.Layout()
        self.Fit()
        
    def __do_evt(self):
        self.Bind(wx.EVT_BUTTON, self.OnExit, id=wx.ID_OK)
        
    def OnExit(self,event):
        self.Destroy()
        FCA = FacebookChoiceAlbumFrame(self.files, self.fb, None, -1, "")
        FCA.Show()

# end of class FacebookOpenSessionDialog


class FacebookChoiceAlbumFrame(wx.Frame):
    
    def __init__(self, files, fb, *args, **kwds):
        self.fb=fb
        self.files=files
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.FCALB = wx.ListBox(self, -1)
        self.FCATC = wx.TextCtrl(self, -1, "")
        self.ID_CHECK=wx.NewId()
        self.FCACB = wx.CheckBox(self, self.ID_CHECK, _("New Album"))
        self.FCABOK = wx.Button(self, wx.ID_OK, "")
        self.FCABC = wx.Button(self, wx.ID_CLOSE, "")
        self.__set_properties()
        self.__do_layout()
        self.__do_evt()

    def __set_properties(self):
        self.SetTitle(_("Facebook Choice album"))
        _icon = wx.EmptyIcon()
        _icon.CopyFromBitmap(wx.Bitmap(ICON_PATH, wx.BITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        self.Center()
        self.FCATC.Enable(False)
        self.SetSize((400, 300))

    def __do_layout(self):
        FCAS = wx.BoxSizer(wx.VERTICAL)
        FCASB = wx.BoxSizer(wx.HORIZONTAL)
        FCAS.Add(self.FCALB, 1, wx.LEFT|wx.RIGHT|wx.TOP|wx.EXPAND|wx.ADJUST_MINSIZE, 5)
        FCAS.Add(self.FCATC, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 5)
        FCASB.Add(self.FCACB, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        FCASB.Add(self.FCABOK, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        FCASB.Add(self.FCABC, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        FCAS.Add(FCASB, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.ALIGN_RIGHT, 5)
        self.SetSizer(FCAS)
        self.Layout()
        self.SetSize((400, 300))
        
    def __do_evt(self):
        self.Bind(wx.EVT_CHECKBOX, self.OnCheck, id=self.ID_CHECK)
        self.Bind(wx.EVT_SHOW, self.OnShow)
        self.Bind(wx.EVT_BUTTON, self.OnExit, id=wx.ID_CLOSE)
        self.Bind(wx.EVT_BUTTON, self.OnStart, id=wx.ID_OK)
        self.Bind(EVT_SET_ALBUMS, self.setChoices)
        self.Bind(EVT_CLEAR_ALBUMS, self.clearAlbums)
    
    def OnStart(self,event):
        if self.FCALB.IsEnabled():
            if self.FCALB.GetSelection() == -1:
                dlg = wx.MessageDialog(self,_("Please, select an album"),_('Information'),wx.OK | wx.ICON_INFORMATION)
                dlg.ShowModal()
                self.FCALB.SetFocus()
            else:
                self.Destroy()
                aidAlbum=self.lAlbums[self.FCALB.GetSelection()]['aid']
                urlAlbum=self.lAlbums[self.FCALB.GetSelection()]['link']
                FU=FacebookUploadDialog(self.fb, self.files, aidAlbum, urlAlbum, None, -1, "")
                FU.Show()
        elif self.FCATC.IsEnabled():
            if self.FCATC.IsEmpty():
                dlg = wx.MessageDialog(self,_("Please, insert album name"),_('Information'),wx.OK | wx.ICON_INFORMATION)
                dlg.ShowModal()
                self.FCATC.SetFocus()
            else:
                self.Destroy()
                tmp=self.fb.createAlbum(self.FCATC.GetValue())
                aidAlbum=tmp[0]
                urlAlbum=tmp[1]
                FU=FacebookUploadDialog(self.fb, self.files, aidAlbum, urlAlbum, None, -1, "")
                FU.Show()
        
    def OnExit(self,event):
        self.Destroy()
    
    def clearAlbums(self,event):
        self.FCALB.Clear()    
    
    def setChoices(self,event):
        self.FCALB.SetItems(event.values)
        self.FCABOK.Enable(True)
        self.FCACB.Enable(True)
        
    def getAlbums(self,main):
        try:
            tmp=main.fb.getAlbums()
        except:
            dlg = wx.MessageDialog(self,_("Error in fetch the albums"),_('Error'),wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            self.Destroy()
        main.lAlbums=main.fb.removeProfilePictureAlbum(tmp)
        choices=[]
        for album in main.lAlbums:
            choices.append(album['name'])
        evtClear = clearAlbums()
        evtSet = setAlbums(values=choices)
        wx.PostEvent(main,evtClear)
        wx.PostEvent(main,evtSet)
        
    def OnShow(self,event):
        self.FCABOK.Enable(False)
        self.FCACB.Enable(False)
        self.FCALB.SetItems([_("Fetching albums...")])
        thread.start_new_thread(self.getAlbums, (self,))
        self.Unbind(wx.EVT_SHOW)
        
    def OnCheck(self,event):
        if self.FCACB.IsChecked():
            self.FCALB.Enable(False)
            self.FCATC.Enable(True)
            self.FCATC.SetFocus()
        else:
            self.FCALB.Enable(True)
            self.FCATC.Enable(False)
            self.FCALB.SetFocus()

# end of class FacebookChoiceAlbumFrame


class FacebookUploadDialog(wx.Dialog):
    def __init__(self, fb, files, aidAlbum, urlAlbum, *args, **kwds):
        self.fb = fb
        self.files=files
        self.totalsize=0
        for file in self.files:
            self.totalsize=self.totalsize+os.stat(file).st_size
        self.aidAlbum=aidAlbum
        self.urlAlbum=urlAlbum
        self.stop=False
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.FUDG = wx.Gauge(self, -1, self.totalsize)
        self.FUDST = wx.StaticText(self, -1, "", style=wx.ALIGN_LEFT)
        self.FUDBS = wx.Button(self, wx.ID_STOP, "")
        self.FUDBC = wx.Button(self, wx.ID_CLOSE, "")
        self.timer = wx.Timer(self)
        self.__set_properties()
        self.__do_layout()
        self.__do_evt()

    def __set_properties(self):
        self.SetTitle(_("Facebook Upload"))
        _icon = wx.EmptyIcon()
        _icon.CopyFromBitmap(wx.Bitmap(ICON_PATH, wx.BITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        self.SetSize((400, 100))

    def __do_layout(self):
        FUDS = wx.BoxSizer(wx.VERTICAL)
        FUDSB = wx.BoxSizer(wx.HORIZONTAL)
        FUDS.Add(self.FUDG, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 5)
        FUDS.Add(self.FUDST, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 5)
        FUDSB.Add(self.FUDBS, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        FUDSB.Add(self.FUDBC, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL|wx.ADJUST_MINSIZE, 5)
        FUDS.Add(FUDSB, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.ALIGN_RIGHT, 5)
        self.SetSizer(FUDS)
        self.Layout()
        
    def __do_evt(self):
        self.Bind(wx.EVT_BUTTON, self.OnExit, id=wx.ID_CLOSE)
        self.Bind(wx.EVT_SHOW, self.OnShow)
        self.Bind(EVT_SET_PROGRESS, self.setFUDGValue)
        self.Bind(EVT_SET_LABEL, self.setFUDSTSetLabel)
        self.Bind(wx.EVT_BUTTON, self.OnStop, id=wx.ID_STOP)
        self.Bind(EVT_SET_STATS, self.setUploadTitle)
        
    def OnStop(self,event):
        self.stop=True
        self.FUDBS.Enable(False)
        
    def setFUDSTSetLabel(self,event):
        self.FUDST.SetLabel(event.value)
        self.Fit()
        self.SetSize((400, self.GetSize()[1]+10))
        if event.ended:
            self.FUDBS.Enable(False)
            self.FUDBC.Enable(True)
            
    def setUploadTitle(self,event):
        self.SetTitle("Facebook Upload - "+str(event.perc)+" % ("+event.rate+")")
        
    def getResizedImage(self,image):
        im1 = Image.open(image)
        w,h = im1.size
        if w > h:
            size = (604, (604*h)/w)
        elif h > w:
            size = ((604*w)/h, 604)
        elif w == h:
            size = (604, 604)
        im2 = im1.resize(size, Image.ANTIALIAS)
        dir = os.path.dirname(image)
        file = os.path.basename(image)
        newdir=os.path.sep+"tmp"+os.path.sep+"tmpfbupload"
        newfile=newdir+os.path.sep+file
        if not os.path.exists(newdir):
            os.makedirs(newdir)
        im2.save(newfile)
        return newfile
        
    def uploadPhotos(self,main):
        count = 0
        total = len(self.files)
        headerLabel = ""
        percentage = 0
        error = False
        for file in main.files:
            if main.stop: break
            tmp = os.path.basename(file)
            msg = _("Image resize in progress: %s") % tmp
            evtSetLabel = setLabel(value=headerLabel+msg,ended=False)
            wx.PostEvent(main,evtSetLabel)
            oldfile = file
            newfile = self.getResizedImage(file) 
            msg = _("Upload in progress: %s") % tmp
            evtSetLabel = setLabel(value=headerLabel+msg,ended=False)
            wx.PostEvent(main,evtSetLabel)
            try:
                starttime = time.time()
                main.fb.load(newfile, self.aidAlbum)
                deltatime = time.time()-starttime
            except:
                error=True
                headerLabel = _("Error while uploading file: %s\n") % tmp
            count = count+1
            if count == total:
                percentage = main.totalsize
            else:
                if error:
                    percentage = percentage+main.totalsize/total
                    error = False
                else:
                    percentage = percentage+os.stat(oldfile).st_size
            perc = percentage*100/main.totalsize
            rate = (os.stat(newfile).st_size/deltatime)/1024.0
            if rate > 1024:
                rate = str(round(rate/1024.0,2))+" MB/s"
            else:
                rate = str(round(rate,2))+" KB/s"
            evtStats = setStats(rate=rate,perc=perc)
            wx.PostEvent(main,evtStats)
            evtSet = setProgress(progress=percentage)
            wx.PostEvent(main,evtSet)
        if main.stop:
            evtSetLabel = setLabel(value=headerLabel+_("Upload stopped"),ended=True)
            wx.PostEvent(main,evtSetLabel)
        else:
            evtSetLabel = setLabel(value=headerLabel+_("Upload finished"),ended=True)
            wx.PostEvent(main,evtSetLabel)
        
    def OnShow(self,event):
        thread.start_new_thread(self.uploadPhotos, (self,))
        self.FUDBC.Enable(False)
        self.Unbind(wx.EVT_SHOW)
        
    def setFUDGValue(self,event):
        self.FUDG.SetValue(event.progress)
        
    def OnExit(self,event):
        self.Destroy()
        webbrowser.open(self.urlAlbum)

# end of class FacebookUploadDialog

if __name__ == "__main__":
    #Only for debug and test
    FacebookUpload = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    os.chdir('/home/pidy/Immagini/Varie/Sample Pictures')
    files=os.listdir('/home/pidy/Immagini/Varie/Sample Pictures')
    FOS = FacebookOpenSessionDialog(files, None, -1, "")
    FacebookUpload.SetTopWindow(FOS)
    FOS.Show()
    FacebookUpload.MainLoop()
