#!/usr/bin/env python
# -*- coding: utf-8 -*-

#---------------------------------------------------------------------------------------------------
# Copyright (C) 2009 Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com>.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# Contributors:
#     Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com> - initial API and implementation
#---------------------------------------------------------------------------------------------------

DEBUG=False
import warnings
with warnings.catch_warnings():
    warnings.simplefilter("ignore")
    import facebook

class PhotoUpload:
    
    api_key = '61854eeb27fa2c5bb787a7dd98078c2a'
    secret_key = 'e29635b455aa6b5f2abeb5694ca740bd'
    
    def __init__(self):
        self.fb = facebook.Facebook(self.api_key,self.secret_key)
        self.fb.auth.createToken()
        self.fb.login()
        
    def getAlbums(self):
        self.fb.auth.getSession()
        return self.fb.photos.getAlbums()
    
    def createAlbum(self,name):
        tmp=self.fb.photos.createAlbum(name)
        rs=[]
        rs.append(tmp['aid'])
        rs.append(tmp['link'])
        return rs
    
    def removeProfilePictureAlbum(self,albums):
        count = 0
        for album in albums:
            if (album['link']).find('aid=-3') != -1: idx=count
            count+=1
        albums.pop(idx)
        return albums
    
    def load(self,file,aid):
        self.fb.photos.upload(file,aid=aid)

if __name__ == '__main__':
    import sys
    import os
    import imghdr
    import webbrowser
    import fnmatch
    import gettext, locale
    locale.setlocale(locale.LC_ALL, '')
    gettext.install("fbupload")
    print "\nfbphotoupload  Copyright (C) 2009  Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com"
    print "This program comes with ABSOLUTELY NO WARRANTY."
    print "This is free software, and you are welcome to redistribute it"
    print "under certain conditions.\n"
    args = sys.argv[1:]
    if len(args) == 0:
        if DEBUG: print "DEBUG - Nessun parametro"
        path = os.path.curdir
        pat = "*"
    elif len(args) == 1:
        if DEBUG: print "DEBUG - Un parametro"
        path = os.path.expanduser(args[0])
        if os.path.isdir(path):
            if DEBUG: print "DEBUG - Il parametro è una directory"
            pat = "*"
        else:
            if DEBUG: print "DEBUG - Il parametro non è una directory"
            pat = os.path.basename(path)
            path = os.path.dirname(path)
            if len(path) == 0:
                path = os.path.curdir
        if not os.path.isdir(path):
            print _("Can not find the path specified (%s)") % path
            sys.exit(1)
    else:
        print _("Parameter incorrect")
        sys.exit(1)
    try:
        print _("Connection to your facebook account in progress .. A browser window is in opening, follow the instructions")
        try:
            fb = PhotoUpload()
        except:
            print _("Connection Error")
            sys.exit(1)
        raw_input(_("Press any key to continue")) 
        print _("Gets the albums from Your Profile")
        tmp=fb.getAlbums()
        lAlbums=fb.removeProfilePictureAlbum(tmp)
        print _("\nChoose the abum on which upload photos:")
        i=1
        for album in lAlbums:
            print str(i)+". "+album['name']
            i=i+1
        print _("n. New Album")
        idx=raw_input(_("Choose: "))
        if idx=="n":
            name=raw_input(_("\nNew album name:"))
            tmp=fb.createAlbum(name)
            aidAlbum=tmp[0]
            urlAlbum=tmp[1]
            print _("Album created")
        else:
            aidAlbum=lAlbums[int(idx)-1]['aid']
            urlAlbum=lAlbums[int(idx)-1]['link']
        print "\n"
        found=False
        if DEBUG: print "DEBUG - pat:"+pat
        if DEBUG: print "DEBUG - path:"+path
        for file in os.listdir(path):
            fullpath = path+os.path.sep+file
            if (os.path.isfile(fullpath)):
                if imghdr.what(fullpath):
                    if DEBUG: print "DEBUG - file: "+file
                    if fnmatch.fnmatch(file, pat):
                        found=True
                        print _("Upload in progress: %s") % file
                        try:
                            fb.load(fullpath, aidAlbum)
                        except:
                            err = _("Error while uploading file: %s") % file
                            print "\033[91m"+err+"\033[0m"
        if found:
            print _("\nUpload finished, opening browser for approval of the photos")
            webbrowser.open(urlAlbum)
        else:
            print _("\nNo photos found in the directory specified (%s)") % path
        sys.exit(0)
    except KeyboardInterrupt:
        print "\n"
        sys.exit(1)
