#!/usr/bin/env python
# -*- coding: utf-8 -*-

#---------------------------------------------------------------------------------------------------
# Copyright (C) 2009 Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com>.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# Contributors:
#     Giuseppe Buzzanca (PiDy) <giuseppebuzzanca@gmail.com> - initial API and implementation
#---------------------------------------------------------------------------------------------------

from distutils.core import setup
from DistUtilsExtra.command import build_extra,build_i18n,build_help,build_icons
import os, sys

def getDataFiles():
    data = []
    if sys.platform.startswith('linux'):
        data.append((os.path.join('lib','nautilus','extensions-2.0','python'),[os.path.join('.','fbphotouploadnautilus.py')]))
        data.append((os.path.join('share','pixmaps'),[os.path.join('.','FBUIcon.png')]))
    return data

def getScriptFile():
    data=[]
    if sys.platform.startswith('linux'):
        data.append(os.path.join('.','fbphotoupload'))
    else:
        data.append(os.path.join('.','fbphotoupload.bat'))
    return data        

setup(
      name='fbupload',
      version='0.1',
      author='Giuseppe Buzzanca',
      author_email='giuseppebuzzanca@gmail.com',
      maintainer='Giuseppe Buzzanca',
      maintainer_email='giuseppebuzzanca@gmail.com',
      description='Python modules for send images to your facebook account',
      long_description='A terminal application and a python-nautilus extension for upload all the images contains in a directory in a facebook account, can create a new album or upload in an existing.  Is possible to load it as a python module for use the implemented methods.',
      license='gpl',
      packages=['fbupload'],
      data_files=getDataFiles(),
      scripts=getScriptFile(),
      requires=['facebook','wx','nautilus'],
      cmdclass = { "build" : build_extra.build_extra,
                   "build_i18n" :  build_i18n.build_i18n,
                   "build_help" :  build_help.build_help,
                   "build_icons" :  build_icons.build_icons }
      )
